#include <io.h>
#include <stdio.h>
#include "gmStream.h"

class gmFileStream : public gmStream
{
public:
	gmFileStream( const char* Filename, bool Create = false )
	{
		if( Create )
			_File = fopen( Filename, "wb" );
		else
			_File = fopen( Filename, "rb" );
		
		m_flags = F_READ | F_WRITE | F_SIZE | F_SEEK | F_TELL;
	}

	~gmFileStream() { fclose( _File ); }

	unsigned int Seek(unsigned int p_pos)
	{
		unsigned int CurrentPos = ftell( _File );
		fseek( _File, p_pos, SEEK_SET );
		return CurrentPos;
	}

	unsigned int Tell() const { return ftell( _File ); }
	unsigned int GetSize() const { return filelength( _File->_file ); }

	unsigned int Read(void * p_buffer, unsigned int p_n)
	{
		unsigned int NumBytes = fread( p_buffer, sizeof(char), p_n, _File );
		if( feof(_File) ) m_flags |= F_EOS;

		return NumBytes;
	};

	unsigned int Write(const void * p_buffer, unsigned int p_n) { return fwrite( p_buffer, sizeof(char) , p_n, _File ); };

private:
	FILE* _File;
};