#ifndef GM_TMP_H
#define GM_TMP_H

#pragma warning ( disable: 4244 )

#define FUNCTION_TYPE 1
#define METHODE_TYPE 2
#define CONSTRUCTOR_TYPE 3
#define FUNCTION_OPERATOR_TYPE 4
#define METHODE_OPERATOR_TYPE 5
#define VARIABLE_TYPE 6

#define DESTRUCTOR_VIRTUAL_TYPE 7
#define BASECLASS_VIRTUAL_TYPE 8
#define POOL_VIRTUAL_TYPE 9
#define END_VIRTUAL_TYPE 10

#define IS_CONST 1
#define IS_NOT_CONST 0

#define GET_SET_ACCESS 0
#define DIRECT_ACCESS 1

#define GM_UNKNOWN 7
#define GM_THREAD_LAUNCH_INFO 8
#define GM_ANY_PTR 9
#define GM_CONST_ANY_PTR 10
#define GM_C_STRING 11
#define GM_CONST_C_STRING 12

#define GM_OBJ -3
#define GM_OBJ_PTR -4
#define GM_OBJ_CONST_PTR -5

/*=============================================================================================
  Template qui permet d'avoir le gmType correspondant a un type C++ au moment de la compilation
===============================================================================================*/

template<typename T> struct GET					{ static const int Type = GM_OBJ; };
template<typename T> struct GET<T*>				{ static const int Type = GM_OBJ_PTR; };
template<typename T> struct GET<const T*>		{ static const int Type = GM_OBJ_CONST_PTR; };

template<> struct GET<void>						{ static const int Type = GM_NULL; };
template<> struct GET<void*>					{ static const int Type = GM_ANY_PTR; }; 
template<> struct GET<const void*>				{ static const int Type = GM_CONST_ANY_PTR; };

template<> struct GET<bool>						{ static const int Type = GM_INT; };
template<> struct GET<const bool>				{ static const int Type = GM_INT; };
template<> struct GET<char>						{ static const int Type = GM_INT; };
template<> struct GET<const char>				{ static const int Type = GM_INT; };
template<> struct GET<int>						{ static const int Type = GM_INT; };
template<> struct GET<const int>				{ static const int Type = GM_INT; };
template<> struct GET<short>					{ static const int Type = GM_INT; };
template<> struct GET<const short>				{ static const int Type = GM_INT; };
template<> struct GET<long>						{ static const int Type = GM_INT; };
template<> struct GET<const long>				{ static const int Type = GM_INT; };
template<> struct GET<long long>				{ static const int Type = GM_INT; };
template<> struct GET<const long long>			{ static const int Type = GM_INT; };
template<> struct GET<unsigned char>			{ static const int Type = GM_INT; };
template<> struct GET<const unsigned char>		{ static const int Type = GM_INT; };
template<> struct GET<unsigned int>				{ static const int Type = GM_INT; };
template<> struct GET<const unsigned int>		{ static const int Type = GM_INT; };
template<> struct GET<unsigned short>			{ static const int Type = GM_INT; };
template<> struct GET<const unsigned short>		{ static const int Type = GM_INT; };
template<> struct GET<unsigned long>			{ static const int Type = GM_INT; };
template<> struct GET<const unsigned long>		{ static const int Type = GM_INT; };
template<> struct GET<unsigned long long>		{ static const int Type = GM_INT; };
template<> struct GET<const unsigned long long>	{ static const int Type = GM_INT; };

template<> struct GET<float>					{ static const int Type = GM_FLOAT; };
template<> struct GET<const float>				{ static const int Type = GM_FLOAT; };
template<> struct GET<double>					{ static const int Type = GM_FLOAT; };
template<> struct GET<const double>				{ static const int Type = GM_FLOAT; };
template<> struct GET<long double>				{ static const int Type = GM_FLOAT; };
template<> struct GET<const long double>		{ static const int Type = GM_FLOAT; };

template<> struct GET<char*>					{ static const int Type = GM_C_STRING; };
template<> struct GET<const char*>				{ static const int Type = GM_CONST_C_STRING; };

template<> struct GET<gmStringObject*>			{ static const int Type = GM_STRING; };
template<> struct GET<const gmStringObject*>	{ static const int Type = GM_STRING; };

template<> struct GET<gmTableObject*>			{ static const int Type = GM_TABLE; };
template<> struct GET<const gmTableObject*>		{ static const int Type = GM_TABLE; };

template<> struct GET<gmFunctionObject*>		{ static const int Type = GM_FUNCTION; };
template<> struct GET<const gmFunctionObject*>	{ static const int Type = GM_FUNCTION; };

template<> struct GET<gmUserObject*>			{ static const int Type = GM_USER; };
template<> struct GET<const gmUserObject*>		{ static const int Type = GM_USER; };


/*======================================================
  Template qui fait la conversion C++ -> GM et GM -> C++
========================================================*/

template<gmType GM_TYPE, typename CPP_TYPE> struct CONVERT {};

template<typename CPP_TYPE> struct CONVERT<GM_INT,CPP_TYPE>
{
	static inline int ToCpp( gmVariable& Var ){ return ATC<int>(&Var); }
	static inline gmVariable ToGm( int Val, gmMachine*, gmType ){ return gmVariable( Val ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_FLOAT,CPP_TYPE>
{
	static inline float ToCpp( gmVariable& Var ){ return ATC<float>(&Var); }
	static inline gmVariable ToGm( float Val, gmMachine*, gmType ){ return gmVariable( Val ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_STRING,CPP_TYPE>
{
	static inline gmStringObject* ToCpp( gmVariable& Var ){ return (gmStringObject*)Var.m_value.m_ref; }
	static inline gmVariable ToGm( const gmStringObject* pStringObj, gmMachine*, gmType ){ return gmVariable( (gmStringObject*)pStringObj ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_TABLE,CPP_TYPE>
{
	static inline gmTableObject* ToCpp( gmVariable& Var ){ return (gmTableObject*)Var.m_value.m_ref; }
	static inline gmVariable ToGm( const gmTableObject* Table, gmMachine*, gmType ){ return gmVariable( (gmTableObject*)Table ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_FUNCTION,CPP_TYPE>
{
	static inline gmFunctionObject* ToCpp( gmVariable& Var ){ return (gmFunctionObject*)Var.m_value.m_ref; }
	static inline gmVariable ToGm( const gmFunctionObject* Function, gmMachine*, gmType ){ return gmVariable( (gmFunctionObject*)Function ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_OBJ,CPP_TYPE>
{
	static inline CPP_TYPE ToCpp( gmVariable& Var ){ return *(REMOVE_REF<CPP_TYPE>::Type*)((gmUserObject*)Var.m_value.m_ref)->m_user; }
	static inline gmVariable ToGm( CPP_TYPE Obj, gmMachine* VM, gmType Type ){ return gmVariable( VM->AllocUserObject( new REMOVE_REF<CPP_TYPE>::Type(Obj), Type ) ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_OBJ_PTR,CPP_TYPE>
{
	static inline CPP_TYPE ToCpp( gmVariable& Var ){ return (CPP_TYPE)((gmUserObject*)Var.m_value.m_ref)->m_user; }
	static inline gmVariable ToGm( CPP_TYPE pObj, gmMachine* VM, gmType Type ){ return gmVariable( VM->AllocUserObject( pObj, Type ) ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_OBJ_CONST_PTR,CPP_TYPE>
{
	static inline CPP_TYPE ToCpp( gmVariable& Var ){ return (CPP_TYPE)((gmUserObject*)Var.m_value.m_ref)->m_user; }
	static inline gmVariable ToGm( CPP_TYPE pObj, gmMachine* VM, gmType Type ){ return gmVariable( VM->AllocUserObject( (void*)pObj, Type ) ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_C_STRING,CPP_TYPE>
{
	static inline char* ToCpp( gmVariable& Var ){ return const_cast<char*>( ATC<const char*>(&Var) ); }
	//static inline gmVariable ToGm( char* Text, gmMachine* VM, gmType ){ return gmVariable( VM->AllocPermanantStringObject( Text ) ); }
	static inline gmVariable ToGm( char* Text, gmMachine* VM, gmType ){ return gmVariable( VM->AllocUserObject( Text, GM_C_STRING ) ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_CONST_C_STRING,CPP_TYPE>
{
	static inline char* ToCpp( gmVariable& Var ){ return ATC<const char*>(&Var); }
	//static inline gmVariable ToGm( const char* Text, gmMachine* VM, gmType ){ return gmVariable( VM->AllocPermanantStringObject( Text ) ); }
	static inline gmVariable ToGm( const char* Text, gmMachine* VM, gmType ){ return gmVariable( VM->AllocUserObject( (void*)Text, GM_CONST_C_STRING ) ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_ANY_PTR,CPP_TYPE>
{
	static inline void* ToCpp( gmVariable& Var ){ return ((gmUserObject*)Var.m_value.m_ref)->m_user; }
	static inline gmVariable ToGm( void* Ptr, gmMachine* VM, gmType ){ return gmVariable( VM->AllocUserObject( Ptr, GM_ANY_PTR ) ); }
};

template<typename CPP_TYPE> struct CONVERT<GM_CONST_ANY_PTR,CPP_TYPE>
{
	static inline const void* ToCpp( gmVariable& Var ){ return ((gmUserObject*)Var.m_value.m_ref)->m_user; }
	static inline gmVariable ToGm( const void* Ptr, gmMachine* VM, gmType ){ return gmVariable( VM->AllocUserObject( (void*)Ptr, GM_CONST_ANY_PTR ) ); }
};


/*==============================================================================================================================================================
  Templates qui permettent la compilation conditionnelle, selon que la fonction accepte tels nombre de paramtres, son type (fonction/methode/operateur/ctor ...
================================================================================================================================================================*/

template<bool Condition> struct IF
{
	template<typename RET, typename FUNCTION> static inline gmVariable Call0Param( const FUNCTION pFunc, gmThread*, const gmType* ) //fonctions ne retournant aucune valeurs
	{
		(*pFunc)();
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename FUNCTION> static inline gmVariable Call1Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );

		(*pFunc)(Param1);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename FUNCTION> static inline gmVariable Call2Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );

		(*pFunc)(Param1,Param2);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename FUNCTION> static inline gmVariable Call3Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );

		(*pFunc)(Param1,Param2,Param3);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename FUNCTION> static inline gmVariable Call4Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );

		(*pFunc)(Param1,Param2,Param3,Param4);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename FUNCTION> static inline gmVariable Call5Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );

		(*pFunc)(Param1,Param2,Param3,Param4,Param5);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename FUNCTION> static inline gmVariable Call6Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );

		(*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename FUNCTION> static inline gmVariable Call7Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );

		(*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename FUNCTION> static inline gmVariable Call8Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );

		(*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename FUNCTION> static inline gmVariable Call9Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );

		(*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9);
		return gmVariable::s_null;
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename FUNCTION> static inline gmVariable Call10Param( const FUNCTION pFunc, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );
		P10 Param10 = CONVERT< GET<P10>::Type, P10 >::ToCpp( pThread->Param(9) );

		(*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9,Param10);
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename METHODE> static inline gmVariable Call0Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* ) //mthodes ne retournant aucune valeur
	{
		(pObj->*pMeth)();
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename METHODE> static inline gmVariable Call1Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );

		(pObj->*pMeth)(Param1);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename METHODE> static inline gmVariable Call2Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );

		(pObj->*pMeth)(Param1,Param2);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename METHODE> static inline gmVariable Call3Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );

		(pObj->*pMeth)(Param1,Param2,Param3);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename METHODE> static inline gmVariable Call4Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename METHODE> static inline gmVariable Call5Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename METHODE> static inline gmVariable Call6Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename METHODE> static inline gmVariable Call7Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename METHODE> static inline gmVariable Call8Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename METHODE> static inline gmVariable Call9Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename METHODE> static inline gmVariable Call10Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );
		P10 Param10 = CONVERT< GET<P10>::Type, P10 >::ToCpp( pThread->Param(9) );

		(pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9,Param10);
		return gmVariable::s_null;
	} 

	template<class CLASS, typename TYPE> static inline void Set( CLASS* pObj, TYPE CLASS::*, void (CLASS::*pSet)(TYPE), gmVariable& Var){ (pObj->*pSet)( CONVERT< GET<TYPE>::Type, TYPE >::ToCpp( Var ) ); } //Set pour accs indirect
	template<class CLASS, typename TYPE> static inline gmVariable Get( CLASS* pObj, TYPE CLASS::*, TYPE (CLASS::*pGet)(), gmMachine* VM, gmType Type ){ return CONVERT< GET<TYPE>::Type, TYPE >::ToGm( (pObj->*pGet)(), VM, Type ); } //Get pour accs indirect

	template<typename TYPE> static inline void Push(TYPE, gmThread*){}
	template<class CLASS> static inline void Destruct(gmUserObject* pGmObj, gmMachine* VM){ delete (CLASS*)pGmObj->m_user; VM->AdjustKnownMemoryUsed( - sizeof(CLASS) ); }
};


template<> struct IF<true>
{
	template<typename RET, typename FUNCTION> static inline gmVariable Call0Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType ) //fonctions retournant une valeur
	{
		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename FUNCTION> static inline gmVariable Call1Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1), pThread->GetMachine(), GmType[1] );
	}
	
	template<typename RET, typename P1, typename P2, typename FUNCTION> static inline gmVariable Call2Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename FUNCTION> static inline gmVariable Call3Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename FUNCTION> static inline gmVariable Call4Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename FUNCTION> static inline gmVariable Call5Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4,Param5), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename FUNCTION> static inline gmVariable Call6Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename FUNCTION> static inline gmVariable Call7Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename FUNCTION> static inline gmVariable Call8Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename FUNCTION> static inline gmVariable Call9Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9), pThread->GetMachine(), GmType[1] );
	}

	template<typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename FUNCTION> static inline gmVariable Call10Param( const FUNCTION pFunc, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );
		P10 Param10 = CONVERT< GET<P10>::Type, P10 >::ToCpp( pThread->Param(9) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (*pFunc)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9,Param10), pThread->GetMachine(), GmType[1] );
	}

	
	template<class CLASS, typename RET, typename METHODE> static inline gmVariable Call0Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType ) //methodes retournant une valeur
	{ 
		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename METHODE> static inline gmVariable Call1Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename METHODE> static inline gmVariable Call2Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename METHODE> static inline gmVariable Call3Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename METHODE> static inline gmVariable Call4Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename METHODE> static inline gmVariable Call5Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename METHODE> static inline gmVariable Call6Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename METHODE> static inline gmVariable Call7Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename METHODE> static inline gmVariable Call8Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename METHODE> static inline gmVariable Call9Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename METHODE> static inline gmVariable Call10Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );
		P10 Param10 = CONVERT< GET<P10>::Type, P10 >::ToCpp( pThread->Param(9) );

		return CONVERT< GET<RET>::Type, RET >::ToGm( (pObj->*pMeth)(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9,Param10), pThread->GetMachine(), GmType[1] );
	}

	template<class CLASS, typename TYPE> static inline void Set( CLASS* pObj, TYPE CLASS::*pVar, void (CLASS::*)(TYPE), gmVariable& Var) { pObj->*pVar = CONVERT< GET<TYPE>::Type, TYPE >::ToCpp( Var ); } //Set pour accs direct 
	template<class CLASS, typename TYPE> static inline gmVariable Get( CLASS* pObj, TYPE CLASS::*pVar, TYPE (CLASS::*)(), gmMachine* VM, gmType Type ) { return CONVERT< GET<TYPE>::Type, TYPE >::ToGm( pObj->*pVar, VM, Type ); } //Get pour accs direct

	template<typename TYPE> static inline void Push(TYPE Param, gmThread* pThread ){ pThread->Push( CONVERT< GET<TYPE>::Type, TYPE >::ToGm( Param, pThread->GetMachine(), ( GET<TYPE>::Type >= GM_NULL && GET<TYPE>::Type < GM_USER ) ? GET<TYPE>::Type : GetTypeId<TYPE>()  ) ); }
	template<class CLASS> static inline void Destruct(gmUserObject* pGmObj, gmMachine*)
	{
		std::map<const gmType,gmClassDef*>::const_iterator i = gmMachineEx::ClassList.find( pGmObj->m_userType );

		if( i != gmMachineEx::ClassList.end() )
		{
			gmClassDef* pDef = i->second;

			if( pDef)
			{
				std::multimap<const int,gmProxy*>::const_iterator i = pDef->FuncList.find( 4294967295 );

				if( i != pDef->FuncList.end() )
				{
					gmProxy* pProxy = i->second;
					if( pProxy )
						(*pProxy)( NULL, pGmObj->m_user );
				}
			}
		}
	}
};


template<int Case> struct SWITCH
{
	template<class CLASS, typename RET, typename FUNCTION> static inline gmVariable Call0Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename FUNCTION> static inline gmVariable Call1Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename FUNCTION> static inline gmVariable Call2Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename FUNCTION> static inline gmVariable Call3Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename FUNCTION> static inline gmVariable Call4Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename FUNCTION> static inline gmVariable Call5Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename FUNCTION> static inline gmVariable Call6Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename FUNCTION> static inline gmVariable Call7Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename FUNCTION> static inline gmVariable Call8Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename FUNCTION> static inline gmVariable Call9Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }	
	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename FUNCTION> static inline gmVariable Call10Param( const FUNCTION, CLASS*, gmThread*, const gmType* ){ return gmVariable::s_null; }
};

template<> struct SWITCH<FUNCTION_TYPE>
{
	template<class CLASS, typename RET, typename FUNCTION> static inline gmVariable Call0Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call0Param<RET,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename FUNCTION> static inline gmVariable Call1Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call1Param<RET,P1,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename FUNCTION> static inline gmVariable Call2Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call2Param<RET,P1,P2,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename FUNCTION> static inline gmVariable Call3Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call3Param<RET,P1,P2,P3,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename FUNCTION> static inline gmVariable Call4Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call4Param<RET,P1,P2,P3,P4,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename FUNCTION> static inline gmVariable Call5Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call5Param<RET,P1,P2,P3,P4,P5,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename FUNCTION> static inline gmVariable Call6Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call6Param<RET,P1,P2,P3,P4,P5,P6,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename FUNCTION> static inline gmVariable Call7Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call7Param<RET,P1,P2,P3,P4,P5,P6,P7,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename FUNCTION> static inline gmVariable Call8Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call8Param<RET,P1,P2,P3,P4,P5,P6,P7,P8,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename FUNCTION> static inline gmVariable Call9Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call9Param<RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename FUNCTION> static inline gmVariable Call10Param( const FUNCTION pFunc, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		if( pFunc )
			return IF< GET<RET>::Type != GM_NULL >::Call10Param<RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,FUNCTION>( pFunc, pThread, GmType );
		
		return gmVariable::s_null;
	}
};

template<> struct SWITCH<METHODE_TYPE>
{
	template<class CLASS, typename RET, typename METHODE> static inline gmVariable Call0Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call0Param<CLASS,RET,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename METHODE> static inline gmVariable Call1Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call1Param<CLASS,RET,P1,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename METHODE> static inline gmVariable Call2Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call2Param<CLASS,RET,P1,P2,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename METHODE> static inline gmVariable Call3Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call3Param<CLASS,RET,P1,P2,P3,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename METHODE> static inline gmVariable Call4Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call4Param<CLASS,RET,P1,P2,P3,P4,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename METHODE> static inline gmVariable Call5Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call5Param<CLASS,RET,P1,P2,P3,P4,P5,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename METHODE> static inline gmVariable Call6Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call6Param<CLASS,RET,P1,P2,P3,P4,P5,P6,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename METHODE> static inline gmVariable Call7Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call7Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename METHODE> static inline gmVariable Call8Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call8Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,P8,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename METHODE> static inline gmVariable Call9Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call9Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename METHODE> static inline gmVariable Call10Param( const METHODE pMeth, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pMeth && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call10Param<CLASS,RET,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,METHODE>( pMeth, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}
};

template<> struct SWITCH<CONSTRUCTOR_TYPE>
{
	template<class CLASS, typename RET, typename FUNCTION> static gmVariable Call0Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		CLASS* pObj = new CLASS;
		
		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename FUNCTION> static gmVariable Call1Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 1 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );

		CLASS* pObj = new CLASS(Param1);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename FUNCTION> static gmVariable Call2Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 2 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );

		CLASS* pObj = new CLASS(Param1,Param2);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename FUNCTION> static gmVariable Call3Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 3 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename FUNCTION> static gmVariable Call4Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 4 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename FUNCTION> static gmVariable Call5Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 5 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4,Param5);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename FUNCTION> static gmVariable Call6Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 6 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4,Param5,Param6);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename FUNCTION> static gmVariable Call7Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 7 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4,Param5,Param6,Param7);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename FUNCTION> static gmVariable Call8Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 8 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8);

		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename FUNCTION> static gmVariable Call9Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 9 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9);
		
		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7, typename P8, typename P9, typename P10, typename FUNCTION> static gmVariable Call10Param( const FUNCTION, CLASS*, gmThread* pThread, const gmType* GmType )
	{
		GM_ASSERT( pThread->GetNumParams() == 10 );

		P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) );
		P2 Param2 = CONVERT< GET<P2>::Type, P2 >::ToCpp( pThread->Param(1) );
		P3 Param3 = CONVERT< GET<P3>::Type, P3 >::ToCpp( pThread->Param(2) );
		P4 Param4 = CONVERT< GET<P4>::Type, P4 >::ToCpp( pThread->Param(3) );
		P5 Param5 = CONVERT< GET<P5>::Type, P5 >::ToCpp( pThread->Param(4) );
		P6 Param6 = CONVERT< GET<P6>::Type, P6 >::ToCpp( pThread->Param(5) );
		P7 Param7 = CONVERT< GET<P7>::Type, P7 >::ToCpp( pThread->Param(6) );
		P8 Param8 = CONVERT< GET<P8>::Type, P8 >::ToCpp( pThread->Param(7) );
		P9 Param9 = CONVERT< GET<P9>::Type, P9 >::ToCpp( pThread->Param(8) );
		P10 Param10 = CONVERT< GET<P10>::Type, P10 >::ToCpp( pThread->Param(9) );

		CLASS* pObj = new CLASS(Param1,Param2,Param3,Param4,Param5,Param6,Param7,Param8,Param9,Param10);
		
		if( pObj && pThread )
		{
			gmUserObject* pGmObj = pThread->GetMachine()->AllocUserObject( pObj, GmType[0] );
			if( pGmObj )
			{
				pThread->GetMachine()->AdjustKnownMemoryUsed( sizeof(CLASS) );
				return gmVariable( pGmObj );
			}
			else
				delete pObj;
		}
		
		return gmVariable::s_null;
	}
};


template<> struct SWITCH<METHODE_OPERATOR_TYPE>
{
	template<class CLASS, typename RET, typename OPERATOR> static inline gmVariable Call0Param( const OPERATOR pOp, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pOp && pObj )
			return IF< GET<RET>::Type != GM_NULL >::Call0Param<CLASS,RET,OPERATOR>( pOp, pObj, pThread, GmType );
		
		return gmVariable::s_null;
	}

	template<class CLASS, typename RET, typename P1, typename OPERATOR> static inline gmVariable Call1Param( const OPERATOR pOp, CLASS* pObj, gmThread* pThread, const gmType* GmType )
	{
		if( pOp && pObj )
		{
			if( pThread->GetNumParams() < 3 )
				//return IF< GET<RET>::Type != GM_NULL >::Call1Param<CLASS,RET,P1,OPERATOR>( pOp, pObj, pThread, GmType );
				return IF< GET<REMOVE_REF<RET>::Type>::Type != GM_NULL >::Call1Param<CLASS,REMOVE_REF<RET>::Type,P1,OPERATOR>( pOp, pObj, pThread, GmType );
			else
			{
				P1 Param1 = CONVERT< GET<P1>::Type, P1 >::ToCpp( pThread->Param(0) ); //normalement Param(1) mais l'inversion a ete faite par OperatorDispatcher
				(pObj->*pOp)(Param1) = CONVERT< GET<REMOVE_REF<RET>::Type>::Type, REMOVE_REF<RET>::Type >::ToCpp( pThread->Param(2) );
			}
		}
		
		return gmVariable::s_null;
	}
};


template<class CLASS> struct ADJUST
{
	typedef CLASS* TYPE;
	static const bool isObj = true;
};

template<class CLASS> struct ADJUST<CLASS&>
{
	typedef CLASS* TYPE;
	static const bool isObj = true;
};

template<class CLASS> struct ADJUST<CLASS*>
{
	typedef CLASS* TYPE;
	static const bool isObj = false;
};

template<class CLASS> struct ADJUST<const CLASS*>
{
	typedef const CLASS* TYPE;
	static const bool isObj = false;
};

template<class CLASS> struct REMOVE_REF
{
	typedef CLASS Type;
};

template<class CLASS> struct REMOVE_REF<CLASS&>
{
	typedef CLASS Type;
};




template<class DUMMY, typename OPERATOR> bool isUnary( OPERATOR Op ) //la classe factice est la car VC++ est bugg
{
	return _isUnary( Op );
};

template<typename RET, typename P1> bool _isUnary( RET (*)(P1) )
{
	return true;
};

template<typename RET, typename P1, typename P2> bool _isUnary( RET (*)(P1,P2) )
{
	return false;
};

template<class _CLASS, typename RET> bool _isUnary( RET (_CLASS::*)() )
{
	return true;
};

template<class _CLASS, typename RET> bool _isUnary( RET (_CLASS::*)() const )
{
	return true;
};

template<class _CLASS, typename RET, typename P1> bool _isUnary( RET (_CLASS::*)(P1) )
{
	return false;
};

template<class _CLASS, typename RET, typename P1> bool _isUnary( RET (_CLASS::*)(P1) const )
{
	return false;
};


#pragma warning ( default: 4244 )

#endif