#ifndef GM_VARIABLE_EX_H
#define GM_VARIABLE_EX_H

/*========================================================================================================
  Une extension de la structure gmVariable de base bcp plus simple a utiliser grace aux oprateurs de cast
==========================================================================================================*/

struct gmVariableEx : public gmVariable
{
	gmVariableEx(){m_type=GM_NULL;}
	explicit gmVariableEx(int iVal) : gmVariable( iVal ){}
	explicit gmVariableEx(float fVal) : gmVariable( fVal ){}
	explicit gmVariableEx(gmStringObject* String) : gmVariable( String ){}
	explicit gmVariableEx(gmTableObject* pTable) : gmVariable( pTable ){}
	explicit gmVariableEx(gmFunctionObject* pFunc) : gmVariable( pFunc ){}
	explicit gmVariableEx(gmUserObject* pGmObj) : gmVariable( pGmObj ){}

	bool operator==( gmType Type ) const { return m_type == Type; }
	bool operator!=( gmType Type ) const { return m_type != Type; }
	bool operator<=( gmType Type ) const { return m_type <= Type; }
	bool operator>=( gmType Type ) const { return m_type >= Type; }
	bool operator< ( gmType Type ) const { return m_type < Type; }
	bool operator> ( gmType Type ) const { return m_type > Type; }

	#ifdef AUTO_RESULT_CONVERSION
		operator int() const { return ATC<int>( this ); }
		operator float() const { return ATC<float>( this ); }
		operator const char*() const { return ATC<const char*>( this ); }


		operator char*() const
		{
			const char* Temp = ATC<const char*>( this );

			if( Temp )
			{
				size_t Length = strlen( Temp );
				char* NewString = new char[ Length + 1 ];
				if( NewString )
				{
					strcpy( NewString, Temp );
					NewString[ Length ] = '\0';
					return NewString;
				}
			}
			
			return NULL;
		}
	#else
		operator int() const { if( m_type == GM_INT ) return m_value.m_int; else return 0; }
		operator float() const { if( m_type == GM_FLOAT ) return m_value.m_float; else return 0.0f; };
		operator const char*() const { if( m_type == GM_STRING ) return ((gmStringObject*)m_value.m_ref)->GetString(); else return NULL; }

		operator char*() const
		{
			if( m_type == GM_STRING )
			{
				const char* Temp = ((gmStringObject*)m_value.m_ref)->GetString();

				if( Temp )
				{
					size_t Length = strlen( Temp );
					char* NewString = new char[ Length + 1 ];
					if( NewString )
					{
						strcpy( NewString, Temp );
						NewString[ Length ] = '\0';
						return NewString;
					}
				}
			}
			
			return NULL;
		}
	#endif

	operator gmStringObject*()		const { if( m_type == GM_STRING	)	return ((gmStringObject*)m_value.m_ref)				; else return NULL; }
	operator gmFunctionObject*()	const { if( m_type == GM_FUNCTION ) return (gmFunctionObject*)m_value.m_ref				; else return NULL; }
	operator gmTableObject*()		const { if( m_type == GM_TABLE )	return (gmTableObject*)m_value.m_ref				; else return NULL; }
	operator gmUserObject*()		const { if( m_type > GM_USER )		return (gmUserObject*)m_value.m_ref					; else return NULL; }

	template<class T> operator T*(){ return (T*)((gmUserObject*)m_value.m_ref)->m_user; }


	int toInt() const {	return ATC<int>( this ); }
	float toFloat() const {	return ATC<float>( this ); }
	const char* toConstString() const { return ATC<const char*>( this ); }

	char* toString() const
	{
		const char* Temp = ATC<const char*>( this );

		if( Temp )
		{
			size_t Length = strlen( Temp );
			char* NewString = new char[ Length + 1 ];
			if( NewString )
			{
				strcpy( NewString, Temp );
				NewString[ Length ] = '\0';
				return NewString;
			}
		}
			
		return NULL;
	}

	gmStringObject* toStringObj()	const { if( m_type == GM_STRING	)	return (gmStringObject*)m_value.m_ref				; else return NULL; }
	gmFunctionObject* toFunction()	const { if( m_type == GM_FUNCTION ) return (gmFunctionObject*)m_value.m_ref				; else return NULL; }
	gmTableObject* toTable()		const { if( m_type == GM_TABLE )	return (gmTableObject*)m_value.m_ref				; else return NULL; }
	gmUserObject* toUserObj()		const { if( m_type > GM_USER )		return (gmUserObject*)m_value.m_ref					; else return NULL; }
	template<class T> T toUser()	const { if( m_type > GM_USER )		return (T)((gmUserObject*)m_value.m_ref)->m_user	; else return NULL; }

	template<class T> void toUser( T& Obj ) const { if( m_type > GM_USER )	 Obj = (T)((gmUserObject*)m_value.m_ref)->m_user; }
};

#endif